#ifndef __isp_if_h__
#define __isp_if_h__

/* SpartanII ISP universal hardware I/F driver structure */

typedef struct isp_driver
{
// JTAG mode interface
	int (*jtag_init)(DWORD port_address);	// initialize PROBE
	int (*jtag_power)(void);				// sense TargetPower
	int (*jtag_txrx)(const BYTE *ibuf,BYTE *obuf,DWORD drsize,int tms_s,int tms_e); // JTAG access
	void (*jtag_end)(void);					// end of PROBE controll
// SlaveSerial interface
	int (*ss_init)(DWORD port_address);			// initialize PROBE
	int (*ss_power)(void);						// sense TargetPower
	int (*ss_tx)(const BYTE *data,DWORD size_bytes);	// TX configration data
	int (*ss_program)(BYTE level);				// sense PROGRAM pin
	int (*ss_done)(void);						// sense DONE pin
	void (*ss_end)(void);						// end of PROBE controll
}ISP_PROBE;

#endif
