/*
	Xiliinx SpartanII Configrater with Cypress EZ-USB Ver.0.9

	Copyright(c) 2002 Tatsuyuki Satoh

	EEZ-USBgSpartanIIRtBO[V܂B
	ESpartanIĨVAX[u[hƁAoE_XL[hɑΉ
	E\[Xt@ĆAXilinx Webpacko͂bitstream
	@t@C(*.bit)ɑΉ܂B
	  Awb_̉ǂ100%ł͂Ȃ̂ŁAo[W
	  Ă͓Ȃ܂B

	note:

	@RpC̓t[̃RpCAMINGWgpĂ܂B

	@̃vÓAEZ-USBI/FɁACypressЂ́udy|trap̊J
	LbgvƃIveB}CÝuJIUSBvp̐\tgx[XɎg
	pĂ܂B

	@N"L"IvVƌJԂs[hɂȂAݐ
	Abitstreamt@C폜āAVɓÕt@C쐬
	̂҂܂B
	@vWFNgfBNgbitstreamt@Cݒ肵Ă΁AXilinx
	fUCc[ŃRpCAIɃ_E[h邱Ƃł܂B

*/
#include <windows.h>
#include <stdio.h>

/* support universal driver */
#define UNIVERSAL_DRIVER 1

#if UNIVERSAL_DRIVER
#include "isp_if.h"		// universal driver struct
#include "isp_par.h"	// PROBE I/F for Pararell Port
#include "isp_usb.h"	// PROBE I/F for EZ-USB
#endif
#include "xilinxbit.h"	// Xilinx bistream file handler

// Pararell port Address / USB select
static int par_port;

// Maximum of trasnfer size
#define TX_MAX 32768
// Config File Buffer
BYTE file_buffer[TX_MAX];


/* -------------------- PROBE hardware dependent interface macros -------------------- */
#define UNIVERSAL_DRIVER 1

#if !UNIVERSAL_DRIVER

/* fixed driver */
#if SUPOPORT_JTAG
extern int jtag_init(DWORD port_address);
extern int jtag_power(void);
extern void jtag_end(void);
/*
	JTAG_TX_RX
		const BYTE ibuf : pointer of transmit buffer to TDI (MSB fitst)
		BYTE obuf       : pointer of receive buffer from TDO (MSB first)
		BYTE numbits    : number of transfer bits
		BYTE tmss       : TMS pin level for start to end-1 in TCK
		BYTE tmse       : TMS pin level for last TCK
		return int      : error code
*/
extern int jtag_txrx(const BYTE *ibuf,BYTE *obuf,DWORD numbits,int tmss,int tmse);
extern void jtag_end(void);

/* macros of Hardware Driver Function */
#define PROBE_INIT(PARAM)  jtag_init(PARAM)
#define PROBE_POWER(PARAM) jtag_power(PARAM)
#define PROBE_END(PARAM)   jtag_end(PARAM)
#define JTAG_TXRX(IBUF,OBUF,SIZE,TMSS,TMSE) jtag_txrx(IBUF,OBUF,SIZE,TMSS,TMSE)
#define CONFIG_START()     jtag_start()
#define CONFIG_WRITE()     jtag_write()
#endif
#if SS_SUPPORT
// SlaveSerial interface
extern int ss_init(DWORD port_address);
extern int ss_power(void);
/*
	SS_TX
		const BYTE data : pointer of transmit buffer to DIN (MSB fitst)
		BYTE numbytes   : number of transfer bytes
		return int      : error code
*/
extern int ss_tx(const BYTE *data,DWORD numbytes);
extern int ss_program(BYTE level);
extern int ss_done(void);
extern void ss_end(void);

/* macros of Hardware Driver Function */
#define PROBE_INIT(PARAM)  ss_init(PARAM)
#define PROBE_POWER(PARAM) ss_power(PARAM)
#define PROBE_END(PARAM)   ss_end(PARAM)
#define SS_TX(DATA,SIZE)   ss_tx(DATA,SIZE)
#define SS_PROGRAM(LEVEL)  ss_program(LEVEL)
#define SS_DONE()          ss_done()
#define CONFIG_START()     ss_start()
#define CONFIG_WRITE()     ss_write()
#endif

#else // !UNIVERSAL_DRIVER

/* universal selectable driver*/
#include "isp_if.h"

/* Hardware Driver struct */
static ISP_PROBE *probe;

/* macros of Hardware Driver Function */
#define PROBE_INIT(PARAM)  (jtag_mode?probe->jtag_init(PARAM):probe->ss_init(PARAM))
#define PROBE_POWER()      (jtag_mode?probe->jtag_power():probe->ss_power())
#define PROBE_END()        (jtag_mode?probe->jtag_end():probe->ss_end())
#define JTAG_TXRX(IBUF,OBUF,SIZE,TMSS,TMSE) probe->jtag_txrx(IBUF,OBUF,SIZE,TMSS,TMSE)
#define SS_TX(DATA,SIZE) probe->ss_tx(DATA,SIZE)
#define SS_PROGRAM(LEVEL) probe->ss_program(LEVEL)
#define SS_DONE() probe->ss_done()
#define CONFIG_START() (jtag_mode?jtag_start():ss_start())
#define CONFIG_WRITE(B,S,L) (jtag_mode?jtag_write(B,S,L):ss_write(B,S,L))

#endif // !UNIVERSAL_DRIVER


/* ̏ */

/* -------------------- SerialSlave Configration -------------------- */

// e|[g̏
#define CF_RESET 0x00 // PROGRAM = L
#define CF_RUN   0x01 // PROGRAM = H
#define CF_DONE(port) ((port)&2)
#define CF_INIT(port) ((port)&4)
#define CF_VCC(port)  ((port)&8)

// CONFIG_START() : SerialSlave ConfigJn
int ss_start(void)
{
	// PROGRAMskɂB
	SS_PROGRAM(0);
	sleep(50);
	// PROGRAMsgɂ@*/
	SS_PROGRAM(1);
	sleep(50); /* INIT=HɂȂ܂ł܂ */

	return 0;
}

// SerialSlave ubNݏ
int ss_write(BYTE *data,DWORD size,int last)
{
	SS_TX(data,size);
	if(last)
	{
		// Check DONE pin = H
		if( SS_DONE() )
		{
			printf("DONE = H\n");
			return 0;
		}
		else
		{
			printf("DONE = L\n");
			return 1;
		}
	}
	return 0;
}

/* -------------------- BounderyScan(JTAG) Configration -------------------- */
/*
	Xilinx XAPP188 (v2.0)
*/
#define CF_TMS 1
#define CF_TDO(port) ((port)&2)

/* StartanII JTAG Instructions */
#define EXTEST   0
#define SAMPLE   1
#define USER1    2
#define USER2    3
#define CFG_OUT  4
#define CFG_IN   5
#define INTEST   7
#define USERCODE 8
#define IDCODE   9
#define HIGHZ    10
#define JSTART   12
#define bypass   31

// swap bits in BYTE data
static BYTE swap_byte(BYTE value)
{
	BYTE ret = 0;

	if(value&0x01) ret |= 0x80;
	if(value&0x02) ret |= 0x40;
	if(value&0x04) ret |= 0x20;
	if(value&0x08) ret |= 0x10;
	if(value&0x10) ret |= 0x08;
	if(value&0x20) ret |= 0x04;
	if(value&0x40) ret |= 0x02;
	if(value&0x80) ret |= 0x01;

	return ret;
}

// 4xBYTE to DWORD conversion (bigendian)
static DWORD byte_to_dword(BYTE *data)
{
	return (DWORD)data[3]*0x1000000 |
		   (DWORD)data[2]*0x10000   |
		   (DWORD)data[1]*0x100     |
		   (DWORD)data[0];
}

// swap bits in DWORD data
static DWORD swap_dword(DWORD value)
{
	DWORD ret = 0;
	int b;
	
	for(b=0;b<32;b++)
	{
		if( value & (1<<b) )
			ret |= 0x80000000>>b;
	}
	return ret;
}

// JTAG DR shift phase
void jtag_dr(const BYTE *ibuf,BYTE *obuf,int drsize,int finish)
{
	int c;

	if(finish)
	{
		JTAG_TXRX(ibuf,obuf,drsize,0,1);
		//update -DR state
		JTAG_TXRX(NULL,NULL,1,1,1);
	}
	else
		JTAG_TXRX(ibuf,obuf,drsize,0,0);
}

// JTAG Instruction Write
void jtag_inst(BYTE cmd,int need_reset,const BYTE *ibuf,BYTE *obuf,int drsize,int finish)
{
	// Logic reset +  run idle mode
	if(need_reset)
		JTAG_TXRX(NULL,NULL,6,1,0);

	// Enter SELECT-IR state : 2clock
	JTAG_TXRX(NULL,NULL,2,1,1);
	// Enter SHIFT-IR state : 2clock
	JTAG_TXRX(NULL,NULL,2,0,0);
	// Loading instruction & exiting SHIFT-IR
	cmd = swap_byte(cmd);
	JTAG_TXRX(&cmd,NULL,5,0,1);
	// Etner SELECT-DR state
	JTAG_TXRX(NULL,NULL,2,1,1);
	// Etner SHIFT-DR state
	JTAG_TXRX(NULL,NULL,2,0,0);

	if(drsize)
		jtag_dr(ibuf,obuf,drsize,finish);
}

// show status register
DWORD jtag_status(void)
{
	BYTE obuf[4];
	DWORD sts;
	static const BYTE sts_data[] = {
		0x28,0x00,0xe0,0x01,
		0x00,0x00,0x00,0x00 };

	static const char *md_str[4] = { "Master-Serial","Boundery-scan","Slave Parallel","Slave Serial"};
	static const char *hl_str[2] = { "H","L" };
	static const char *lock_str[2] = { "LOCK","UNLOCK" };

	// read status
	jtag_inst(CFG_IN,1,sts_data,NULL,sizeof(sts_data)*8,1);
	jtag_inst(CFG_OUT,0,NULL,NULL,1,0); // dummy 1 byte ?
	jtag_dr(NULL,obuf,32,1);

	sts = swap_dword(byte_to_dword(obuf));

	printf("FPGA Status data %08X\n",sts);
	printf("  CRC_ERROR : %s\n",sts&0x0001 ? "ERROR" : "NO ERROR");
//	printf("  ClkDLLs   : %s,%s,%s,%s\n",lock_str[(sts>>1)&1],lock_str[(sts>>2)&1]
//										,lock_str[(sts>>3)&1],lock_str[(sts>>4)&1]);
//	printf("  IN_ERROR  : %s\n",hl_str[(sts>>5)&1]);
//	printf("  GTS_CCFG  : %s\n",hl_str[(sts>>6)&1]);
//	printf("  GWE_B,GSR_B,GHIGH_B : %s,%s,%s\n",hl_str[(sts>>5)&1],hl_str[(sts>>8)&1],hl_str[(sts>>9)&1]);
	printf("  Mode      : %s(%s)\n",md_str[(sts>>10)&3],sts&0x1000 ? "Pullup" : "No-Pullup");
//	printf("  INIT      : %s\n",sts&0x2000 ? "H"     : "L");
	printf("  DONE      : %s\n",sts&0x4000 ? "H"     : "L");

	return sts;
}

// BS shutdown
DWORD jtag_shutdown(void)
{
	static const BYTE sht_data0[] =
{
	0x30,0x01,0x20,0x01,
	0x00,0xa0,0xbf,0x2d,
	0x30,0x00,0x80,0x01,
	0x00,0x00,0x00,0x05,
	0x30,0x00,0x80,0x01, //4.CRC clear
	0x00,0x00,0x00,0x07, //
	0x00,0x00,0x00,0x00}; // flush PIPE

	static const BYTE sht_data1[] =
{
	0x30,0x01,0x20,0x01,
	0x00,0xa0,0x3f,0x2d,
	0x00,0x00,0x00,0x00}; // flush PIPE

	printf("FPGA shutdown\n");

	jtag_inst(CFG_IN,1,sht_data0,NULL,sizeof(sht_data0)*8,1);	// 
	jtag_inst(JSTART,0,NULL,NULL,14,1);							// 5. 6.
	jtag_inst(CFG_IN,0,sht_data1,NULL,sizeof(sht_data1)*8,1);	// 7.
}

// CONFIG_START() : BounderyScan [hARtBOJn
int jtag_start(void)
{
	BYTE ibuf[8];
	BYTE obuf[4];
	DWORD id , sts , rev;
	char *tname;

	// IDCODE read & show
	jtag_inst(IDCODE,1,NULL,obuf,32,1);
	id = byte_to_dword(obuf);
	switch(id & 0x0fffffff)
	{
	case 0x00608093: tname = "XC2S15"; break;
	case 0x0060c093: tname = "XC2S30"; break;
	case 0x00610093: tname = "XC2S50"; break;
	case 0x00614093: tname = "XC2S100"; break;
	case 0x00618093: tname = "XC2S150"; break;
	case 0x0061c093: tname = "XC2S200"; break;
	default: tname = "unknown";
	}
	printf("Device ID code %08XH : %s Rev.%d\n",id,tname,id>>28);

	if( (id == 0xffffffff || id == 0x00000000))
	{
		printf("JTAG DEVICE error\n");
		return 1;
	}

	/* do shutdown */
	jtag_shutdown();

	/* jtag_status(); */

	//Enter CFG_IN phase
	jtag_inst(CFG_IN,1,NULL,NULL,0,0);

	return 0;
}

// BounderyScan [hARtBOf[^ݏ
int jtag_write(BYTE *data,DWORD size,int last)
{
	//phase 9,10,11
	jtag_dr(data,NULL,size*8,last);
	//ŌH
	if(last)
	{
		//phase 12,13,14,15,16,17,18
		jtag_inst(JSTART,0,NULL,NULL,14,1);
		//phase 19 RUN idle
		JTAG_TXRX(NULL,NULL,1,0,0);
		// show status
		jtag_status();
	}
	return 0;
}

/* ------------------------------ MAIN ----------------------------- */

// C
int main(int argc,char *argv[])
{
	BIT_FILE *hndl;
	DWORD file_size;
	char filename[128];
	DWORD file_pos,tx_size;
	int last_block;
	int c;
	char *p;
	int continus_mode,jtag_mode;
	int err;

	// ^Cg\
	printf("\n\
Xilinx SpartanII Configrater with Cypress EZ-USB Ver.0.9\n\
Copyrght(c) 2002 Tatsuuki Satoh\n");

	// R}hC̉
	continus_mode = 0;
#if UNIVERSAL_DRIVER
	par_port = 0;
	jtag_mode = 1;
#endif
	filename[0] = 0x00;
	for( c=1 ; c<argc ; c++ )
	{
		p = argv[c];
		if( *p == '/' || *p == '-')
		{
			p++;
			while(p && *p != 0x00)
			{
				// IvVXCb`
				switch( (*p++)|0x20 )
				{
				case 'c': continus_mode = 1; break;
#if UNIVERSAL_DRIVER
				case 'j': jtag_mode = 1;     break;
				case 's': jtag_mode = 0;     break;
				case 'p': par_port = 0x378; sscanf(p,"%X",&par_port); p = NULL;break;
#endif
				}
			}
		}
		else
		{
			// bitstreamt@C
			sprintf(filename,"%s.bit",p);
		}
	}

	if( filename[0] == 0)
	{
		printf("\n\
useage: spcusb [Xilinx_bit_file] [options]\n\
  options :\n\
       -C       : continus mode\n\
       -J       : JTAG mode (default)\n\
       -S       : SlaveSerial mode\n\
       -U       : use EZ-USB probe(default)\n\
       -P[port] : use Parallel I/F probe \n");
		exit(1);
	}

	// show PROBE type
	printf("probe type  : ");
	if( par_port )
		printf("Xilinx Parallel (%04X)\n",par_port);
	else
		printf("EZ-USB(AN2135SC)\n");

#if UNIVERSAL_DRIVER
	// n[hEFAɂ킹hCo[I
	probe = par_port ? &par_probe : &ezusb_probe;

	// [hɂ킹֐̐ݒ
	if(jtag_mode)
	{	/* JTAG mode */
		printf("MODE        : JTAG\n");
	}
	else
	{	/* SlaveSerial mode */
		printf("MODE        : SerialSlave\n");
	}
#endif

	// Probe Hardware Initialize
	err = PROBE_INIT(par_port);
	if(err)
	{
		switch(err)
		{
		case 2: printf("NO Probe\n");
		case 4: printf("NO Target\n");
		}
		exit(err);
	}

	// Target Power Check
	if( !PROBE_POWER() )
	{
		printf("Target power down\n");
		PROBE_END();
		exit(1);
	}

	// A[h̃[v|Cg
again:
	printf("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n");
	err = 0;

	// FPGAp bitstreamt@CI[v
	if( continus_mode )
		printf("Waiting for create bitstream file '%s'\n",filename);
	while(1)
	{
		hndl = bitfile_open(filename);
		if( !continus_mode || hndl!=NULL)
			break;
		//A[h̎At@C܂ő҂
		sleep(1000);
	}
	if( hndl == NULL )
	{
		printf("Can't open bitstream file '%s'\n",filename);
		err = 2;
	}

	// bitstream t@C̏\
	if(err==0)
	{
		file_size = hndl->bit_size;
		printf("MODE          %s\n",jtag_mode ? "JTAG" : "SerialSlave");
		printf("ConfigFile    '%s'\n",filename);
		printf(" -Netname     '%s'\n"   ,hndl->netname);
		printf(" -TargetDeive '%s'\n"   ,hndl->targetname);
		printf(" -TimeStamp   '%s %s'\n",hndl->date,hndl->time);
		printf(" -ConfigSize  %dbits(%dbytes)\n",file_size*8,file_size);

		if( continus_mode )
			printf("Continus mode\n");
		printf("---------------------------------------------------------------\n");
	}

	// Configration Jn
	if(err==0)
	{
		err |= CONFIG_START();
		printf("Start Configraion\n");
	}


	// RtBO[Vf[^̑M
	for(file_pos=0; err==0 && file_pos<file_size ; file_pos += tx_size)
	{
		// ŏIubNH
		last_block = (file_size <= file_pos+TX_MAX);
		// ]
		tx_size = last_block ? (file_size - file_pos) : TX_MAX;

		//\
		printf("  Condifration bit %7d to -%7d\n",file_pos*8,(file_pos+tx_size)*8-1);

		// bitstreamt@C烊[h
		if( !bitfile_read(hndl,file_buffer,tx_size) )
		{
			printf("File Read Error");
			err |= 1;
			break;
		}
		// PubN̑Mf[^M{݊`FbNiŏIubNj
		err |= CONFIG_WRITE(file_buffer,tx_size,last_block);
	}

	// Complete\
	if(err==0)
		printf("Complete!\n");
	else
		printf("Don't Complete\n");
	
	//RtBOt@C̃N[Y
	if(hndl)
		bitfile_close(hndl);

	// Continius modě㏈
	if ( (err<2) && continus_mode)
	{
		if(err==0)
		{
			// Delete file after complete configration
			printf("Delete bitstream file '%s'\n",filename);
			DeleteFile(filename);
		}
		goto again;
	}

	// free PROBE resource
	PROBE_END();

	exit(err);
}

